{% extends 'pmo_email_attachments/base.html' %}
{% block milestone-chart %}
<div class="milestone-review">
    <div class="right-heading" style="padding-left: 30px; padding-top: 10px;">MILESTONE REVIEW</div>
    <div class="milestone-panel">
        <div id="chart"></div>
    </div>
</div>
{% endblock %}
{% block script_block %}
<script>
    const numDays = 30
    const daysTime = (numDays * 24 * 60 * 60 * 1000)
    let data = []
    let phaseColors = []
    let phases = {{phases | safe}};
    let lastPhaseDate = null;
    let completionDate = null;
    let counter = 1;
    let phaseWithoutDates = [];
    let datePresent = false;
    for (const phase of phases) {
        if (phase.estimated_completion_date) {
            completionDate = new Date(moment(phase.estimated_completion_date).format('YYYY-MM-DD')).getTime()
            lastPhaseDate = completionDate;
            datePresent = true;
        } else {
            completionDate = lastPhaseDate + (7 * counter * 24 * 60 * 60 * 1000);
            counter = counter + 1;
            phaseWithoutDates.push(phase.phase.title);
            datePresent = false;
        }
        if (datePresent) {
            label = [`${phase.phase.title}`, `(${moment(completionDate).format('DD MMMM YYYY')})`]

        } else {
            label = [`${phase.phase.title}`, `(T.B.D)`]

        }
        var record = {
            x: label,
            y: [
                completionDate - daysTime,
                completionDate
            ],
            fillColor: phase.status ? `#056406` : `#465a63`
        }
        data.push(record)
    }

    var options = {
        series: [
            {
                data: data
            }
        ],
        chart: {
            height: 400,
            type: 'rangeBar',
            animations: {
                enabled: false
            },
            toolbar: {
                show: false
            }
        },
        plotOptions: {
            bar: {
                horizontal: true,
                distributed: true,
                dataLabels: {
                    hideOverflowingLabels: false,
                    textAnchor: 'start',
                }
            }
        },
        dataLabels: {
            enabled: false,
            formatter: function (val, opts) {
                var label = opts.w.globals.labels[opts.dataPointIndex]
                var a = moment(val[1]).format('DD MMMM')
                if (phaseWithoutDates.indexOf(label) > -1) {
                    return `${label}(T.B.D)`
                }
                return `${label}(${a})`
            },
            style: {
                colors: ['#FFF'],
            },
            background: {
                enabled: false,
                padding: 25,
                borderRadius: 10,
                borderWidth: 1,
                borderColor: '#fff',
                opacity: 1,
            }
        },
        xaxis: {
            type: 'datetime',
        },
        yaxis: {
            show: true
        },
        grid: {
            row: {
                colors: ['#fff', '#fff'],
                opacity: 1
            }
        },

    };
    var chart = new ApexCharts(document.querySelector("#chart"), options);
    chart.render();
</script>
{% endblock %}
